失眠网,内容丰富有趣,生活中的好帮手!
失眠网 > LeetCode 542. 01 Matrix--C++解法--动态规划

LeetCode 542. 01 Matrix--C++解法--动态规划

时间:2019-11-10 09:59:25

相关推荐

LeetCode 542. 01 Matrix--C++解法--动态规划

LeetCode 542. 01 Matrix–C++解法–动态规划

LeetCode题解专栏:LeetCode题解

LeetCode 所有题目总结:LeetCode 所有题目总结

大部分题目C++,Python,Java的解法都有。

题目地址:01 Matrix - LeetCode

Given a matrix consists of 0 and 1, find the distance of the nearest 0 for each cell.

The distance between two adjacent cells is 1.

Example 1:

Input:[[0,0,0],[0,1,0],[0,0,0]]Output:[[0,0,0],[0,1,0],[0,0,0]]

Example 2:

Input:[[0,0,0],[0,1,0],[1,1,1]]Output:[[0,0,0],[0,1,0],[1,2,1]]

Note:

The number of elements of the given matrix will not exceed 10,000.

There are at least one 0 in the given matrix.

The cells are adjacent in only four directions: up, down, left and right.

这道题目乍一看应该用动态规划做,因为2个样例都可以用动态规划解决。但看了提示后,发现简单的动态规划不行,因为有4个方向。

然后仔细考虑后发现必须要动态规划,不然这道题不能解,时间复杂度太高了。

想找到离1最近0,这个0只能在1的4个方向:左上,左下,右下,右上。

那么让程序从左上遍历一遍,再从右下遍历一遍,即可得到解。

C++解法如下:

class Solution {public:vector<vector<int> > updateMatrix(vector<vector<int> > &matrix) {int rows = matrix.size();if (rows == 0)return matrix;int cols = matrix[0].size();vector<vector<int> > dist(rows, vector<int>(cols, INT_MAX - 100000));//First pass: check for left and topfor (int i = 0; i < rows; i++) {for (int j = 0; j < cols; j++) {if (matrix[i][j] == 0)dist[i][j] = 0;else {if (i > 0)dist[i][j] = min(dist[i][j], dist[i - 1][j] + 1);if (j > 0)dist[i][j] = min(dist[i][j], dist[i][j - 1] + 1);}}}//Second pass: check for bottom and rightfor (int i = rows - 1; i >= 0; i--) {for (int j = cols - 1; j >= 0; j--) {if (i < rows - 1)dist[i][j] = min(dist[i][j], dist[i + 1][j] + 1);if (j < cols - 1)dist[i][j] = min(dist[i][j], dist[i][j + 1] + 1);}}return dist;}};

如果觉得《LeetCode 542. 01 Matrix--C++解法--动态规划》对你有帮助,请点赞、收藏,并留下你的观点哦!

本内容不代表本网观点和政治立场,如有侵犯你的权益请联系我们处理。
网友评论
网友评论仅供其表达个人看法,并不表明网站立场。